$(document).ready(function() {
    // Chargement des sons
    var megumin_explosion = new Audio("ressources/megumin_explosion.mp3");
    var tuturu = new Audio("ressources/tuturu.mp3");

    // Volumes des sons
    megumin_explosion.volume = 0.3;
    tuturu.volume = 0.2;

    var sounds = [ // Tableau des sons
        { "name": "megumin", "s": megumin_explosion },
        { "name": "mayuri", "s": tuturu }
    ];

    var color = ["#F17105", "#D11149", "#6610F2", "#177CC5", "#92A500"]; // Couleurs
    var pics = ["asuka", "kumiko", "chitanda", "yohane"]; // Fonds

    var col_rd = "#FFFFFF";
    var pic_rd = "";

    function changeStyle() {
        // On randomise la couleur
        do {
            col_rd = Math.floor(Math.random() * color.length);
        } while( $("header").css("background-color") == hexToRgbA(color[col_rd]) )

        // On randomise l'image
        do {
            pic_rd = Math.floor(Math.random() * pics.length);
        } while( $("div.image").css("background-image") == 'url("ressources/header_bg_crop_'+ pics[pic_rd] +'.png")' )

        // Changement aléatoire de l'image et de la couleur parce que pourquoi pas ?
        $("header").css("background-color", color[col_rd]);
        $("div.image").css("background", 'url("ressources/header_bg_crop_'+ pics[pic_rd] +'.png") 90% 90% / contain no-repeat');
        // $("div.image").css("background-size", "contain");
        $(".container a").css("background", color[col_rd]);
        $("hr").css("border-color", color[col_rd]);
        $(".container a").hover(function(){
                $(this).css("background", hexToRgbA(color[col_rd], 0.8));
            }, function(){
                $(this).css("background", hexToRgbA(color[col_rd], 1));
        });

        // Changement de la couleur pour Google Chrome Mobile
        $('meta[name=theme-color]').remove();
        $('head').append('<meta name="theme-color" content="'+ color[col_rd] +'">');
    }

    $( document ).ready(function() {
        // On change le style au chargement de la page et avec le bouton de refresh
        changeStyle();

        // Choix aléatoire d'un son et personnage associé à la pression de l'avatar !
        var canPlay = true;
        $("div.avatar").click(function() {
            canPlay = true; // On peut jouer de l'audio
            var sound_rd = Math.floor(Math.random() * sounds.length);

            for(i = 0; i < sounds.length; i++) {
                if(!sounds[i]["s"].paused) { canPlay = false; } // Un audio est déjà joué : on attend
            }
            if(canPlay) {
                sounds[sound_rd]["s"].play();
                $("div.avatar").css("background-image", 'url("ressources/'+ sounds[sound_rd]["name"] +'.png")');
            }
        });

        // Event listeners sur les sons
        for(j = 0; j < sounds.length; j++) {
            sounds[j]["s"].addEventListener('ended', function() {
                $("div.avatar").css("background-image", 'url("https://avatars1.githubusercontent.com/u/12085737?s=400")');
            });
        }
    });

    function hexToRgbA(hex, opacity = 0) {
        var c;
        if(/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)){
            c= hex.substring(1).split('');
            if(c.length== 3){
                c= [c[0], c[0], c[1], c[1], c[2], c[2]];
            }
            c= '0x'+c.join('');
            if(opacity > 0)
                return 'rgba('+[(c>>16)&255, (c>>8)&255, c&255].join(', ')+','+opacity+')';
            else {
                return 'rgb('+[(c>>16)&255, (c>>8)&255, c&255].join(', ')+')';
            }
        }
        throw new Error('Bad Hex');
    }
});
